{      }
program p161n19b;

{$APPTYPE CONSOLE}

uses
  SysUtils, Windows;

const
  Yes = ['Y','y','1'];
  No = ['N','n','0'];
  nl = #13#10;
  ExamsAmount = 5;

type
  TData = record
    Familia : String [30];
    Name : String [20];
    Otchestvo : String [20];
    Course : 1..5;
    Group : 1..255;
    Marks : array [1..5] of 1..5;
  end;
  Tlist = ^TNode;
  TNode = record
    Data : TData;
    Next : TList;
  end;

var
  List: Tlist;

function YN (text: string): Boolean;
var
  c: char;
begin
  repeat
    write (text+' (Y/N): ');
    readln (c);
  until c in Yes+No;
  Result:=c in Yes;
end;

procedure CatchFIO (FIO: String; var X: TData);
begin
  with X do
  begin
    Familia:=Copy(FIO,1,Pos(' ',FIO)-1);
    Delete(FIO,1,Pos(' ',FIO));
    Name:=Copy(FIO,1,Pos(' ',FIO)-1);
    Delete(FIO,1,Pos(' ',FIO));
    Otchestvo:=FIO
  end
end;

function ReadData: TData;
var
  tmp: string;
  i: Byte;
begin
  write (' : ');
  Readln (tmp);
  CatchFIO(tmp,Result);
  with Result do
  begin
    repeat
      write(' : ');
      Readln (i)
    until i in [1..5];
    Course:=i;
    repeat
      write('  : ');
      Readln (i)
    until i in [1..255];
    Group:=i;
    write ('    : ');
    for i:=1 to ExamsAmount do
      read (Marks[i]);
  end;
  readln
end;

function ReadDataFF (var F: TextFile; var X: TData): Boolean; //True if Eof reached
var
  tmp: String;
  i: Byte;
begin
  readln (F,tmp);
  CatchFIO(tmp,X);
  with X do
  begin
    readln (F,Course);
    readln (F,Group);
    for i:=1 to ExamsAmount do
      read (F,Marks[i])
  end;
  readln (F);
  Result:=EoF(F)
end;

procedure MakeList (const pBegin: Tlist);
var
  pPrev,pNext: Tlist;
begin
  pBegin^.Data:=ReadData;
  pPrev:=pBegin;
  while YN(' ?') do
  begin
    New(pNext);
    pPrev^.Next:=pNext;
    pNext^.Data:=ReadData;
    //why auto-initial pNext^.Next? 0_o
    pPrev:=pNext;
  end;
  writeln
end;

function MakeListFF (const FileName: String; const pBegin: Tlist): Word; // -  
var
  F: TextFile;
  pPrev,pNext: Tlist;
  flag: Boolean;
begin
  AssignFile(F,FileName);
  Reset(F);
  flag:=ReadDataFF(F,pBegin^.Data);
  Result:=1;
  pPrev:=pBegin;
  while not flag do
  begin
    New(pNext);
    pPrev^.Next:=pNext;
    flag:=ReadDataFF(F,pNext^.Data);
    pNext^.Next:=nil;   //wtf, why not auto-initial?
    pPrev:=pNext;
    inc(Result)
  end;
  CloseFile(F)
end;

procedure PrintData (var X: TData);
function PrintMarks: String;
  var
    i: Byte;
  begin
    Result:='';
    for i:=1 to ExamsAmount do
      Result:=Result+IntToStr(X.Marks[i])+' '
  end;
begin
  with X do
    writeln (':  '+Familia+nl,
             ':      '+Name+nl,
             ': '+Otchestvo+nl,
             ':   ',Course,nl,
             ': ',Group,nl,
             '  : '+PrintMarks+nl);

end;

procedure PrintList (const pBegin: Tlist);
var
  pPos: Tlist;
begin
  pPos:=pBegin;
  repeat
    PrintData (pPos^.Data);
    pPos:=pPos^.Next;
  until pPos=nil;
end;

//function FindCourse ?

procedure Solve (const pBegin: Tlist);
var
  pPos,pPrev,pNext,p2,pl: Tlist;
begin
  pPos:=pBegin;
  p2:=nil;
  while p2=nil do
    if pPos^.Next<>nil
      then if pPos^.Next^.Data.Course=2
             then p2:=pPos
             else pPos:=pPos^.Next;
  pl:=pPos;
  while pl^.Next<>nil do
    pl:=pl^.Next;

  pl^.Next:=p2^.Next;

end;

begin
  SetConsoleCP(1251);
  SetConsoleOutputCP(1251);
  
  New(List);
  //MakeList(List);
  writeln (' : ',MakeListFF('input.txt',List),nl);
  PrintList(List);
  readln
end.
